<header>
<app-navbar (Textout)="textsearchChangedHandler($event)" [Textbox]="Textbox"></app-navbar>
</header>
<body>
<ng-template #content let-modal>
  <div class="modal-header">
    <h4 class="modal-title">Modal title</h4>
    <button (click)="modal.dismiss('Cross click');clearinputs()" aria-label="Close" class="close" type="button">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>

  <div class="modal-body">

    <form [formGroup]="userForm" >

      <table class="table">
        <tr>
          <td>first Name</td>
          <td><input class="text-dark" formControlName="firstname" type="text"></td>
        </tr>
        <tr>
          <td>Last Name</td>
          <td><input formControlName="lastname" type="text"></td>
        </tr>
        <tr>
          <td>User Name</td>
          <td><input formControlName="username" type="text"></td>
        </tr>
        <tr>
          <td>Email</td>
          <td><input formControlName="email" type="text"></td>
        </tr>
        <tr>
          <td>Password</td>
          <td><input formControlName="password" type="password"></td>
        </tr>
      </table>
    </form>
  </div>
  <div class="modal-footer">
    <button (click)="modal.close('Close click');addUser()" class="btn btn-primary" type="button">Update</button>
    <button (click)="modal.close('Close click');clearinputs()" class="btn btn-danger" type="button">Close</button>
  </div>
</ng-template>


  <ng-template #contentmodif let-modalmodif>
    <div class="modal-header">
      <h4 class="modal-title">Update User</h4>
      <button (click)="modalmodif.dismiss('Cross click');clearinputs()" aria-label="Close" class="close" type="button">
        <span aria-hidden="true">&times;</span>
      </button>
    </div>
    <div class="modal-body">
      <form [formGroup]="userForm">
        <table class="table">
          <tr>
            <td>first Name</td>
            <td><input class="text-dark" formControlName="firstname" type="text"></td>
          </tr>
          <tr>
            <td>Last Name</td>
            <td><input formControlName="lastname" type="text"></td>
          </tr>
          <tr>
            <td>User Name</td>
            <td><input formControlName="username" type="text"></td>
          </tr>
          <tr>
            <td>Email</td>
            <td><input formControlName="email" type="text"></td>
          </tr>
          <tr>
            <td>Password</td>
            <td><input formControlName="password" type="password"></td>
          </tr>
        </table>
      </form>
    </div>

  <div class="modal-footer">
    <button (click)="modalmodif.close('Close click');updateUser()" class="btn btn-primary" type="button">Update</button>
    <button (click)="modalmodif.close('Close click');clearinputs()" class="btn btn-danger" type="button">Close</button>
  </div>
</ng-template>

<div class="container">
  <div class="card ">
    <div class="card-header bg-info ">
      <h6 style="color: white">All Users</h6>
      <button (click)="openVerticallyCentered(content)" class="float-md-right  btn btn-primary mb-2 mr-2">Add User</button>
    </div>
    <div class="d-flex flex-wrap mb-2">
      <div class="card" style="width:400px ;flex: 0 0 19.5%; margin-right: 5px" *ngFor="let u of users ">
        <img class="card-img-top" src="../../assets/img/avatar.png" alt="Card image">
        <div class="card-body">
          <h4 class="card-title">{{u.username +"-|- "+u.roles[0]}}</h4>
          <p class="card-text">{{u.email}}</p>
          <button mat-raised-button color="warn" (click)="deleteUser(u.id)">Delete</button>
          <button mat-raised-button color="primary" (click)="itemmodif(u.id);openVerticallyCenteredModif(contentmodif)">Update</button>

        </div>
      </div>
    </div>

    <table class="table table-bordered">
      <th>First Name</th>
      <th>Last Name</th>
      <th>User Name</th>
      <th>Email</th>
      <th>Action</th>
      <tr *ngFor="let u of users ">
        <td>{{u.firstname}}</td>
        <td>{{u.lastname}}</td>
        <td>{{u.username}}</td>
        <td>{{u.email}}</td>
        <td>
          <button (click)="deleteUser(u.id)" class="btn btn-primary mb-2 mr-2">Delete</button>
          <button (click)="itemmodif(u.id);openVerticallyCenteredModif(contentmodif)" class="btn btn-primary mb-2 mr-2">Update</button>
        </td>
      </tr>
    </table>

    <div >
      <table mat-table [dataSource]="dataSource" matSort class="mat-elevation-z8"  style="width: 100%">

        <!-- Position Column -->
        <ng-container matColumnDef="firstname">
          <th mat-header-cell *matHeaderCellDef mat-sort-header> FIRST NAME </th>
          <td mat-cell *matCellDef="let element"> {{element.firstname}} </td>
        </ng-container>

        <!-- Name Column -->
        <ng-container matColumnDef="lastname">
          <th mat-header-cell *matHeaderCellDef mat-sort-header> LAST Name </th>
          <td mat-cell *matCellDef="let element"> {{element.lastname}} </td>
        </ng-container>

        <!-- Weight Column -->
        <ng-container matColumnDef="username">
          <th mat-header-cell *matHeaderCellDef mat-sort-header> USERNAME </th>
          <td mat-cell *matCellDef="let element"> {{element.username}} </td>
        </ng-container>

        <!-- Symbol Column -->
        <ng-container matColumnDef="email">
          <th mat-header-cell *matHeaderCellDef mat-sort-header> EMAIL </th>
          <td mat-cell *matCellDef="let element"> {{element.email}} </td>
        </ng-container>

        <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
        <tr mat-row *matRowDef="let row; columns: displayedColumns;"></tr>
      </table>

      <mat-paginator [pageSizeOptions]="[5, 10, 20]" showFirstLastButtons></mat-paginator>
    </div>

  </div>

</div>

</body>
<style>
  .example-form {
    min-width: 150px;
    max-width: 500px;
    width: 100%;
  }

  .example-full-width {
    width: 100%;
  }
</style>
